import dayjs from 'dayjs';
import _ from 'lodash';

export default {
    filesFormatter(arr) {
        if (!arr || !arr.length) return [];
        return arr.map((item) => item);
    },
    imageFormatter(arr) {
        if (!arr || !arr.length) return []
        return arr.map(item => ({
            publicUrl: item.publicUrl || ''
        }))
    },
    oneImageFormatter(arr) {
        if (!arr || !arr.length) return ''
        return arr[0].publicUrl || ''
    },
    dateFormatter(date) {
        if (!date) return ''
        return dayjs(date).format('YYYY-MM-DD')
    },
    dateTimeFormatter(date) {
        if (!date) return ''
        return dayjs(date).format('YYYY-MM-DD HH:mm')
    },
    booleanFormatter(val) {
        return val ? 'Yes' : 'No'
    },
    dataGridEditFormatter(obj) {
        return _.transform(obj, (result, value, key) => {
            if (_.isArray(value)) {
                result[key] = _.map(value, 'id');
            } else if (_.isObject(value)) {
                result[key] = value.id;
            } else {
                result[key] = value;
            }
        });
    },
    
        
        usersManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.firstName)
        },
        usersOneListFormatter(val) {
            if (!val) return ''
            return val.firstName
        },
        usersManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.firstName}
            });
        },
        usersOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.firstName, id: val.id}
        },
        
    
        
        rolesManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.name)
        },
        rolesOneListFormatter(val) {
            if (!val) return ''
            return val.name
        },
        rolesManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.name}
            });
        },
        rolesOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.name, id: val.id}
        },
        
    
        
        permissionsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.name)
        },
        permissionsOneListFormatter(val) {
            if (!val) return ''
            return val.name
        },
        permissionsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.name}
            });
        },
        permissionsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.name, id: val.id}
        },
        
    
        
        suppliersManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.supplier_name)
        },
        suppliersOneListFormatter(val) {
            if (!val) return ''
            return val.supplier_name
        },
        suppliersManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.supplier_name}
            });
        },
        suppliersOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.supplier_name, id: val.id}
        },
        
    
        
        customersManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.customer_name)
        },
        customersOneListFormatter(val) {
            if (!val) return ''
            return val.customer_name
        },
        customersManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.customer_name}
            });
        },
        customersOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.customer_name, id: val.id}
        },
        
    
        
        uomsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.uom_name)
        },
        uomsOneListFormatter(val) {
            if (!val) return ''
            return val.uom_name
        },
        uomsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.uom_name}
            });
        },
        uomsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.uom_name, id: val.id}
        },
        
    
        
        warehousesManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.warehouse_name)
        },
        warehousesOneListFormatter(val) {
            if (!val) return ''
            return val.warehouse_name
        },
        warehousesManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.warehouse_name}
            });
        },
        warehousesOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.warehouse_name, id: val.id}
        },
        
    
        
        locationsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.location_name)
        },
        locationsOneListFormatter(val) {
            if (!val) return ''
            return val.location_name
        },
        locationsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.location_name}
            });
        },
        locationsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.location_name, id: val.id}
        },
        
    
        
        itemsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.item_name)
        },
        itemsOneListFormatter(val) {
            if (!val) return ''
            return val.item_name
        },
        itemsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.item_name}
            });
        },
        itemsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.item_name, id: val.id}
        },
        
    
        
    
        
        bomsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.bom_name)
        },
        bomsOneListFormatter(val) {
            if (!val) return ''
            return val.bom_name
        },
        bomsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.bom_name}
            });
        },
        bomsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.bom_name, id: val.id}
        },
        
    
        
    
        
        routingsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.routing_name)
        },
        routingsOneListFormatter(val) {
            if (!val) return ''
            return val.routing_name
        },
        routingsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.routing_name}
            });
        },
        routingsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.routing_name, id: val.id}
        },
        
    
        
        work_centersManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.work_center_name)
        },
        work_centersOneListFormatter(val) {
            if (!val) return ''
            return val.work_center_name
        },
        work_centersManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.work_center_name}
            });
        },
        work_centersOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.work_center_name, id: val.id}
        },
        
    
        
    
        
        machinesManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.machine_name)
        },
        machinesOneListFormatter(val) {
            if (!val) return ''
            return val.machine_name
        },
        machinesManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.machine_name}
            });
        },
        machinesOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.machine_name, id: val.id}
        },
        
    
        
    
        
        reason_codesManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.reason_name)
        },
        reason_codesOneListFormatter(val) {
            if (!val) return ''
            return val.reason_name
        },
        reason_codesManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.reason_name}
            });
        },
        reason_codesOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.reason_name, id: val.id}
        },
        
    
        
        work_ordersManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.work_order_number)
        },
        work_ordersOneListFormatter(val) {
            if (!val) return ''
            return val.work_order_number
        },
        work_ordersManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.work_order_number}
            });
        },
        work_ordersOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.work_order_number, id: val.id}
        },
        
    
        
    
        
        lotsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.lot_number)
        },
        lotsOneListFormatter(val) {
            if (!val) return ''
            return val.lot_number
        },
        lotsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.lot_number}
            });
        },
        lotsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.lot_number, id: val.id}
        },
        
    
        
        serialsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.serial_number)
        },
        serialsOneListFormatter(val) {
            if (!val) return ''
            return val.serial_number
        },
        serialsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.serial_number}
            });
        },
        serialsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.serial_number, id: val.id}
        },
        
    
        
    
        
    
        
        purchase_ordersManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.purchase_order_number)
        },
        purchase_ordersOneListFormatter(val) {
            if (!val) return ''
            return val.purchase_order_number
        },
        purchase_ordersManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.purchase_order_number}
            });
        },
        purchase_ordersOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.purchase_order_number, id: val.id}
        },
        
    
        
    
        
        inspection_plansManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.plan_name)
        },
        inspection_plansOneListFormatter(val) {
            if (!val) return ''
            return val.plan_name
        },
        inspection_plansManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.plan_name}
            });
        },
        inspection_plansOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.plan_name, id: val.id}
        },
        
    
        
        inspection_characteristicsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.characteristic_name)
        },
        inspection_characteristicsOneListFormatter(val) {
            if (!val) return ''
            return val.characteristic_name
        },
        inspection_characteristicsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.characteristic_name}
            });
        },
        inspection_characteristicsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.characteristic_name, id: val.id}
        },
        
    
        
        inspectionsManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.inspection_number)
        },
        inspectionsOneListFormatter(val) {
            if (!val) return ''
            return val.inspection_number
        },
        inspectionsManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.inspection_number}
            });
        },
        inspectionsOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.inspection_number, id: val.id}
        },
        
    
        
    
        
        nonconformancesManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.ncr_number)
        },
        nonconformancesOneListFormatter(val) {
            if (!val) return ''
            return val.ncr_number
        },
        nonconformancesManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.ncr_number}
            });
        },
        nonconformancesOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.ncr_number, id: val.id}
        },
        
    
        
        disposition_codesManyListFormatter(val) {
            if (!val || !val.length) return []
            return val.map((item) => item.disposition_name)
        },
        disposition_codesOneListFormatter(val) {
            if (!val) return ''
            return val.disposition_name
        },
        disposition_codesManyListFormatterEdit(val) {
            if (!val || !val.length) return []
            return val.map((item) => {
              return {id: item.id, label: item.disposition_name}
            });
        },
        disposition_codesOneListFormatterEdit(val) {
            if (!val) return ''
            return {label: val.disposition_name, id: val.id}
        },
        
    
        
    
        
    
}
